# Stratus [![Build Status](https://travis-ci.org/Sitetheory/stratus.svg?branch=master)](https://travis-ci.org/Sitetheory/stratus) [![Join the chat at https://gitter.im/Sitetheory/stratus](https://badges.gitter.im/Sitetheory/stratus.svg)](https://gitter.im/Sitetheory/stratus?utm_source=badge&utm_medium=badge&utm_campaign=pr-badge&utm_content=badge)

## Thesis

The Designer always comes first in the Stratus Layer.  [Read More...](docs/THESIS.md)

## Goals

* Creative Design
* Code-Free Design
* Elegant Simplicity
* Abstract Extensibility
* Optimal Performance

## Frameworks & Libraries

##### Dependent

* Underscore.js

##### Recommended

* Require.js

##### Optional

* Angular.js
* Backbone.js
* React.js

## Usage

#### Deployment

Stratus is built to run within a Require.js Asynchronous Environment with Promises.  For an independent implementation without Require.js, further functionality involving auto-loading dependencies will not be present, so these javascript dependencies and templates will need to be defined directly on the DOM. 

```js
// These examples will be expanded
if (tbd) console.log('tbd');
```

#### Angular

[Read More...](docs/ANGULAR.md)

#### Backbone

[Read More...](docs/BACKBONE.md)

#### React

We don't have any data bindings or Auto-Loading built for React, yet. [Read More...](docs/REACT.md)

## Contributions

Always welcome!  [Read More...](docs/CONTRIBUTING.md)

# License

All information contained herein is, and remains the property of Sitetheory and its suppliers, if any. The intellectual and technical concepts contained herein are proprietary to Sitetheory and its suppliers and may be covered by U.S. and Foreign Patents, patents in process, and are protected by trade secret or copyright law.  Dissemination of this information or reproduction of this material is strictly forbidden unless prior written permission is obtained from Sitetheory.